<?php
/*  Copyright 2002-2003 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This script defines "?action=rss".  It will read the current page
    for a WikiTrail, and then output an RSS 2.0 document with the current
    page as the channel and the pages in the WikiTrail as the items.
*/

SDV($HandleActions['rss'],'HandleRss');
SDV($RssMaxItems,20);
SDV($RssSourceSize,256);
SDV($RssDescSize,80);
SDV($RssChannelFmt,"<?xml version=\"1.0\" ?>
  <rss version=\"2.0\">
    <channel>
      <title>\$WikiTitle - \$Group.\$Title</title>
      <link>\$PageUrl</link>
      <description>\$RssChannelDesc</description>
      <lastBuildDate>\$RssChannelBuildDate</lastBuildDate>
      <generator>\$Version</generator>");
SDV($RssItemFmt,"
        <item>
          <title>\$PageName</title>
          <link>\$PageUrl</link>
          <description>\$RssItemDesc</description>
          <pubDate>\$RssItemPubDate</pubDate>
        </item>");

function HandleRss($pagename) {
  global $RssMaxItems,$RssSourceSize,$RssDescSize,
    $RssChannelFmt,$RssChannelDesc,$RssChannelBuildDate,
    $RssItemFmt,$RssItemDesc,$RssItemPubDate,$GCount;
  $t = ReadTrail($pagename);
  $page = RetrieveAuthPage($pagename,false);
  $cbgmt = $page['time'];
  $r = array();
  for($i=0;$i<count($t) && count($r)<$RssMaxItems;$i++) {
    if (!PageExists($t[$i]['name'])) continue;
    $page = RetrieveAuthPage($t[$i]['name'],false);
    ob_start(); 
    PrintText($t[$i]['name'],substr($page['text'],0,$RssSourceSize));
    $text = ob_get_contents(); ob_end_clean();
    $text = preg_replace("/<.*?>/s","",$text); 
    preg_match("/^(.{0,$RssDescSize}\\s)/s",$text,$match);
    $r[] = array('name' => $t[$i]['name'],'time' => $page['time'],
       'desc' => $match[1]." ...");
    if ($page['time']>$cbgmt) $cbgmt=$page['time'];
  }
  SDV($RssChannelBuildDate,gmstrftime('%a, %d %b %Y %H:%M:%S GMT',$cbgmt));
  SDV($RssChannelDesc,FmtPageName('$Group.$Title',$pagename));
  $GCount = 0;
  header("Content-Type: text/xml");
  print FmtPageName($RssChannelFmt,$pagename);
  foreach($r as $page) {
    $RssItemPubDate = gmstrftime('%a, %d %b %Y %H:%M:%S GMT',$page['time']);
    $RssItemDesc = $page['desc'];
    $GCount = 0;
    print FmtPageName($RssItemFmt,$page['name']);
  }
  print "</channel></rss>\n";
  exit();
}

?>
